'' ============================================================
'' Solid Body Simulation Sampler - dialog for global variables
''
'' Copyright (C) 2006 - Jeff Marshall (coder@execulink.com)
''
'' License: 1) Program is provided as-is.  
''          2) There is no warranty or guarantee.
''          3) There are no other conditions.
''
'' Feel free to use, re-use, or abuse :)
''
'' ============================================================

Option Explicit

#include "jm_gui/jm_gui.bi"
#include "atomseng.bi"
#include "dialog.bi"
#include "jm_gui/jm_string.bi"

dim Shared gOptions as UI_BOX_PTR = 0
dim shared gOptQuit as integer = 0
dim shared gOptRestart as integer = 0

'' TODO: These two helper functions should really be in jmgui
sub SetTextByID (byval box As UI_BOX_PTR, byval id as integer, s as string) 
	dim as UI_BOX_PTR edt
	dim as UI_INPUT_T ptr d
	edt = UI_GetBoxFromID(box, id)
	if (edt) then
		d = UI_GetBoxExtraBytesPtr(edt)
		LINE_BUFFER_SetText(d->buffer, strptr(s), len(s))
	end if
end sub
function GetTextByID (byval box As UI_BOX_PTR, byval id as integer) as string
 	dim s as string
	function = ""
	dim as UI_BOX_PTR edt
	dim as UI_INPUT_T ptr d
	edt = UI_GetBoxFromID(box, id)
	if (edt) then
		d = UI_GetBoxExtraBytesPtr(edt)
		s = space(LINE_BUFFER_GetLength(d->buffer))
		zstr_CopyN(strptr(s), LINE_BUFFER_GetTextPtr(d->buffer), LINE_BUFFER_GetLength(d->buffer))
		function = s
	end if
end function

sub SetCheckByID (byval box as UI_BOX_PTR, byval id as integer, flg as integer)
	dim as UI_BOX_PTR chk
	dim as UI_CHECK_T ptr d
	chk = UI_GetBoxFromID(box, id)
	if (chk) then
		d = UI_GetBoxExtraBytesPtr(chk)
		if (flg) then
			d->checked = 1
		else
			d->checked = 0
		end if
	end if
end sub
function GetCheckByID (byval box as UI_BOX_PTR, byval id as integer) as integer
	dim as UI_BOX_PTR chk
	dim as UI_CHECK_T ptr d
	chk = UI_GetBoxFromID(box, id)
	if (chk) then
		d = UI_GetBoxExtraBytesPtr(chk)
		function = d->checked
	end if
end function

private Function OptionsDlg_BoxProc (ByVal box As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer
	static fnt As JM_FONT_PTR	= 0
	function = 1
	Select Case msgid
	case UI_MSG_CREATE
		if fnt = NULL then
		  UI_SavePalette
			fnt = FONT_CreateFromBmp(6,8,"6x8.bmp")
			UI_RestorePalette
		end if
	case UI_MSG_DESTROY
		if fnt <> NULL then
			FONT_Delete fnt
		end if
	case UI_MSG_PAINT
		FONT_Set fnt
	Case UI_MSG_MOUSE_CLICK
		Select Case UI_GetBoxID(box)
		Case 1 '' Apply
			ATOMSIZE        = Val(GetTextByID( gOptions, 201 ))
			ATOMSPACE       = Val(GetTextByID( gOptions, 202 ))
			MAXSPEED        = Val(GetTextByID( gOptions, 203 ))
			YGRAVITY        = Val(GetTextByID( gOptions, 204 ))
			XGRAVITY        = Val(GetTextByID( gOptions, 205 ))
			BOUNDDECAY      = Val(GetTextByID( gOptions, 206 ))
			DEFORMFACTOR    = Val(GetTextByID( gOptions, 207 ))
			DEFORMTHRESHOLD = Val(GetTextByID( gOptions, 208 ))
			BREAKTHRESHOLD  = Val(GetTextByID( gOptions, 209 ))
			STIFFNESS       = Val(GetTextByID( gOptions, 210 ))
			BONDTHRESHOLD   = Val(GetTextByID( gOptions, 211 ))
			SHOWATOMS       = GetCheckByID( gOptions, 5 )
			SHOWBONDS       = GetCheckByID( gOptions, 6 )
		Case 2 '' Close
			UI_HideBox(gOptions)
		Case 3 '' Restart
		  gOptRestart = True
			UI_HideBox(gOptions)
		Case 4 '' Quit
		  gOptQuit = True
			UI_HideBox(gOptions)
		End Select
		function = 0
	end Select
End Function

private Function MakePair(owner As UI_BOX_PTR, byval num as integer, strCaption as string)
	Dim As UI_BOX_PTR cap, txt
	cap = UI_CreateCaption(owner, 100 + num,   4, 20 * num + 6, 100, 12, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, strCaption)
	txt = UI_CreateInput  (owner, 200 + num, 108, 20 * num + 6,  60, 12, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "")
end function

private Function OptionsDlg_Create(owner As UI_BOX_PTR) As UI_BOX_PTR
	Dim As UI_BOX_PTR frm, btn, cap, chk
	Dim As Integer i, x, y, xx, yy

	frm = UI_CreateFrame(owner, 0,  4,  4,176,284, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL or UI_BOX_FLAG_DRAG)
	btn = UI_CreateButton(frm,  1,  4,  4, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Apply")
	btn = UI_CreateButton(frm,  2, 68,  4, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Close")
	btn = UI_CreateButton(frm,  3,  4,264, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Restart")
	btn = UI_CreateButton(frm,  4, 68,264, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Quit")
	chk = UI_CreateCheck (frm,  5,  4,244, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Show Atoms")
	chk = UI_CreateCheck (frm,  6, 88,244, 60, 16, @OptionsDlg_BoxProc, UI_BOX_FLAG_NORMAL, "Show Bonds")

	MakePair frm,  1, "Atom Size"
	MakePair frm,  2, "Atom Space"
	MakePair frm,  3, "Max Speed"
	MakePair frm,  4, "Y Gravity"
	MakePair frm,  5, "X Gravity"
	MakePair frm,  6, "Rebound Decay"
	MakePair frm,  7, "Deform Factor"
	MakePair frm,  8, "Deform Thresh."
	MakePair frm,  9, "Break Thresh"
	MakePair frm, 10, "Stiffness"
	MakePair frm, 11, "Bond Thresh."

	Function = frm

End Function

Sub OptionsDlg_Show()
	if gOptions = NULL then
		gOptions = OptionsDlg_Create(NULL)		
	end if
	SetTextByID gOptions, 201, ltrim(str(ATOMSIZE))
	SetTextByID gOptions, 202, ltrim(str(ATOMSPACE))
	SetTextByID gOptions, 203, ltrim(str(MAXSPEED))
	SetTextByID gOptions, 204, ltrim(str(YGRAVITY))
	SetTextByID gOptions, 205, ltrim(str(XGRAVITY))
	SetTextByID gOptions, 206, ltrim(str(BOUNDDECAY))
	SetTextByID gOptions, 207, ltrim(str(DEFORMFACTOR))
	SetTextByID gOptions, 208, ltrim(str(DEFORMTHRESHOLD))
	SetTextByID gOptions, 209, ltrim(str(BREAKTHRESHOLD))
	SetTextByID gOptions, 210, ltrim(str(STIFFNESS))
	SetTextByID gOptions, 211, ltrim(str(BONDTHRESHOLD))
	SetCheckByID gOptions, 5, SHOWATOMS
	SetCheckByID gOptions, 6, SHOWBONDS
	UI_ShowBox gOptions
End Sub

Sub OptionsDlg_Hide()
	if (gOptions) then
		UI_HideBox gOptions
	end if
End Sub
